 
from sage.plot.plot3d.shapes import *
S = Cylinder(3/2, 4, color='red')
S += Cylinder(3/2, 4, color='blue').rotate((1,0,0), pi/4)
S.show(frame = False, axes = False, aspect_ratio=1)


from sage.plot.plot3d.shapes import *
S = Cylinder(3/2, 4, color='red')
S += Cylinder(3/2, 4, color='blue').rotate((1,0,0), pi/4)
S += plot3d(lambda x, y: 0.3*x + 0.3*y+1, (-5,5), (-5,5))
S.show(frame = False, axes = False, aspect_ratio=1)
  

from sage.plot.plot3d.shapes import *
S = Cylinder(3/2, 4, color='red', opacity=0.5)
V = plot3d(0, (-2,2), (-4,0)).rotate((1,0,0), pi/2)
VR = V.rotate((0,0,1), pi/2)
S += V.translate(0,-1,0)
S += VR.translate(1,0,0)
S += V.translate(0,1,0)
S += VR.translate(-1,0,0)
S.show(frame = False, axes = False, aspect_ratio=1)
  
  
  
  
from sage.plot.plot3d.shapes import *

h = 10
# cylinder
# P prism
C = Cylinder(sqrt(2), h, color='red', opacity=1, closed=False).translate(0,0,-h/2)
V = plot3d(0, (-1,1), (-h/2,h/2)).rotate((1,0,0), pi/2)
VR = V.rotate((0,0,1), pi/2)
P = V.translate(0,-1,0)
P += VR.translate(1,0,0)
P += V.translate(0,1,0)
P += VR.translate(-1,0,0)

eps = 0.01
rp = sqrt(2)+eps
cu = parametric_plot3d((rp*sin(x), rp*cos(x), cos(7*x)), (x,0,2*pi), thickness=6, plot_points = 200)

# If we draw a curve on a cylinder, from top we see a circle
(C+cu).show(frame = False, axes = False, aspect_ratio=1)

cu2 = parametric_plot3d((x, 1+eps, -(1-x^2)), (x,-1,1), thickness=4, plot_points = 200, color='red')
cu2 += parametric_plot3d((x, -1-eps, -(1-x^2)), (x,-1,1), thickness=4, plot_points = 200, color='red')
cu2 += parametric_plot3d((-1-eps,x, (1-x^2)*cos(2*x*pi)), (x,-1,1), thickness=4, plot_points = 200, color='red')
cu2 += parametric_plot3d((1+eps,x, -(1-x^2)*cos(x*pi)), (x,-1,1), thickness=4, plot_points = 200, color='red')

# If we draw a curve on a 4-prism, from top we see a square
(P+cu2).show(frame = False, axes = False, aspect_ratio=1)


#If you intersect a 4-prismo and a cylinder, the intersection curve will
#be a square from one side and a circle from the other
D = P.rotate((0,0,1), -pi/4).rotate((1,0,0), -pi/4) + C.rotate((1,0,0), pi/4)
D.show(frame = True, axes = True, aspect_ratio=1)














